<div class="help">
<h4>The content of this registry is available in different formats and languages.</h4>
<p>For a complete reference related to this release of the INSPIRE registry, please refer to the <a target="_blank" href="https://ies-svn.jrc.ec.europa.eu/projects/registry-development/wiki/service_R6-3_documentation">INSPIRE registry service release 6.3 - Documentation</a> <span class="glyphicon glyphicon-new-window smallico"></span>.</p>

<p>All the resources available in the INSPIRE registry can be accessed in a number of formats listed below.</p><br/>

<h5>Formats</h5>
<ul>
	<li>HTML - <strong>.html</strong>
	</li>
	<li>XML Registry - <strong>.xml</strong>
	</li>
	<li>XML ISO 19135 (beta) - <strong>.iso19135xml</strong>
	</li>
	<li>ATOM - <strong>.atom</strong>
	</li>
	<li>JSON - <strong>.json</strong>
	</li>
	<li>RDF/XML (beta)- <strong>.rdf</strong>
	</li>
	<li>CSV (beta) - <strong>.csv</strong>
	</li>
</ul><br/>
<h5>The languages currently available are:</h5>
<div clasS="row">
	<div class="col-md-4">
	<ul>
	<li>English - <strong>en</strong></li>
	<li>Bulgarian - <strong>bg</strong></li>
	<li>Czech - <strong>cs</strong></li>
	<li>Croatian - <strong>hr</strong></li>
	<li>Danish - <strong>da</strong></li>
	<li>German - <strong>de</strong></li>
	<li>Greek - <strong>el</strong></li>
	<li>Spanish - <strong>es</strong></li>
	</ul>
	</div>
	<div class="col-md-4">
	<ul>
	<li>Estonian - <strong>et</strong></li>
	<li>Finnish - <strong>fi</strong></li>
	<li>French - <strong>fr</strong></li>
	<li>Hungarian - <strong>hu</strong></li>
	<li>Italian - <strong>it</strong></li>
	<li>Lithuanian - <strong>lt</strong></li>
	<li>Latvian - <strong>lv</strong></li>
	<li>Maltese - <strong>mt</strong></li>
	</ul>
	</div>
	<div class="col-md-4">
	<ul>	
	<li>Dutch - <strong>nl</strong></li>
	<li>Polish - <strong>pl</strong></li>
	<li>Portuguese - <strong>pt</strong></li>
	<li>Romanian - <strong>ro</strong></li>
	<li>Slovak - <strong>sk</strong></li>
	<li>Slovenian - <strong>sl</strong></li>
	<li>Swedish - <strong>sv</strong></li>
	</ul>
	</div>
</div>

<p><strong>Please note:</strong> some of the content is not yet available in all languages. Where this is the case, the English translation will be provided. The GUI translations are provisional and may be improved in future releases.</p> 

<br/>
<h4>If you want to get the resource in a particular format or language you can:</h4>
<ul>
	<li>Use the language selector in the web interface;</li>
	<li>Directly call the resources using its name;</li>
	<li>Call the resource using the content negotiation approach.</li>
</ul>

<br/>
<h4>Direct call</h4>
<p>If you want to directly call the resources using its name you have to follow the naming convention explained in the example below:</p>
<pre>
	<strong>http://{base_uri}/{register_uriname}/{register_uriname}.{language_code}.{format}</strong><br/>
	<strong>http://{base_uri}/{itemclass}/{itemclass}.{language_code}.{format}</strong><br/>
	<strong>http://{base_uri}/{itemclass_collection}/{collection_uriname}/{item_uriname}/{item_uriname}.{language_code}.{format}</strong>
</pre>

<p>You can find the specific "language_code" and "format" in the list above (the codes are highlighted in bold).</p>
<p>Examples:</p>
<ul>
	<li>
		<a target="_blank" href="/codelist/codelist.en.xml">
			/codelist/<strong>codelist.en.xml</strong>
		</a>
	</li>
	<li>
		<a target="_blank" href="/codelist/BreakLineTypeValue/BreakLineTypeValue.fr.html">
			/codelist/BreakLineTypeValue/<strong>BreakLineTypeValue.fr.html</strong>
		</a>
	</li>
	<li>
		<a target="_blank" href="/codelist/GeometryMethodValue/byAdministrator/byAdministrator.sl.xml">
			/codelist/GeometryMethodValue/byAdministrator/<strong>byAdministrator.sl.xml</strong>
		</a>
	</li>
	<li>
		<a target="_blank" href="/applicationschema/applicationschema.it.atom">
			/applicationschema/<strong>applicationschema.it.atom</strong>
		</a>
	</li>
	<li>
		<a target="_blank" href="/featureconcept/WFDRiver/WFDRiver.ro.atom">
			/featureconcept/WFDRiver/<strong>WFDRiver.ro.atom</strong>
		</a>
	</li>
	<li>
		<a target="_blank" href="/glossary/Actor/Actor.de.json">
			/glossary/Actor/Actor.en.json/<strong>Actor.de.json</strong>
		</a>
	</li>
</ul>

<br/>
<h4>Content negotiation</h4>
<p>If you want to call the resources using the content negotiation approach, you have add to the HTTP request the format and language header. Some example are listed below:</p>
<p>Examples:</p>
<ul>
	<li>xml, english: 	 
		<ul>
			<li>URL:
				<br/>
				<strong>
					/codelist</strong>
			</li>
			<li>HTTP header:
				<br/>
				<strong>Accept-Language: en
					<br/>Accept: application/xml
				</strong>
			</li>
		</ul>
	</li>
	<li>atom, english:
		<ul>
			<li>URL:
				<br/>
				<strong>
					/applicationschema/ad</strong>
			</li>
			<li>HTTP header:
				<br/>
				<strong>Accept-Language: en
					<br/>Accept: application/atom+xml
				</strong>
			</li>
		</ul>
	</li>
</ul>
<br/>
<h4>Below you can find all the supported format and their relative http header:</h4>
<ul>
	<li>ATOM: application/atom+xml</li>
	<li>HTML: text/html</li>
	<li>XML Re3gistry: application/xml</li>
	<li>XML ISO 19135 (beta): application/x-iso19135+xml</li>
	<li>JSON: application/json</li>
	<li>RFD/XML (beta): application/rdf+xml </li> 
	<li>CSV (beta): text/csv </li> 
</ul>
</div>
