<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns="http://d01ri1201779.ies.jrc.it/registry">

    <!-- Publisher properties -->
    <xsl:variable name="publisherID" select="'http://publications.europa.eu/resource/authority/corporate-body/JRC'" />
    <xsl:variable name="publisherName" select="'European Commission, Joint Research Centre'" />
    <xsl:variable name="publisherEmail" select="'mailto:inspire-registry-dev@jrc.ec.europa.eu'" />
    <xsl:variable name="publisherHomepage" select="'https://ec.europa.eu/jrc'" />
	
    <!-- Update frequency property -->
    <xsl:variable name="updateFrequency" select="'http://publications.europa.eu/resource/authority/frequency/MONTHLY'" />
	
	
    <!-- ## Register properties [optional] ## -->
    <!-- These is a list of additional properties for the register shared in the federartion.
             The system will automatically share all the registers available in the system with the standard configuration (the url of the descriptor will be the URI of the register; the content negotiation approach is taken).
             - To use a specific URL for the descriptor you can use the "descriptorLocation" attribute. An example is available below (example 1)
             - If the register is relying on another register, it can be specifyed using the "reliesOn" attribute. An example is available below (example 2)
             - The 2 attributes can be combined like in example 3
    -->	
    <xsl:variable name="sharedRegisters" as="element()*">
		
        <!-- Example 1 -->
        <register id="http://localhost/country" reliesOn="http://some.registry.eu/country" />
		
        <!-- Example 2 -->
        <register id="http://localhost/company" descriptorLocation="http://example.registry.eu/example-folder/glossary.ror" reliesOn="http://some.registry.eu/glossary" />
		
        <!--Example 3-->
         <register id="http://localhost/country/COU0003" reliesOn="http://some.registry.eu/COU0003" />
    </xsl:variable>
    
</xsl:stylesheet>
