# Examples files #
In this folder there are two complete examples to get started with the **Re3gistry software**:
- Neutral example: contains a register of region and country and a register of companies (folder: neutral-example)
- INSPIRE registry example: contains registers from the INSPIRE registry (inspire-example).

## Example folder details ##
The following paragraph describes the folders and the files contained in each of the examples.

### Folder: apache-configuration ###
It contains the apache configuration to be used to set up a *web service* with the data produced by the Re3gistry software.

More info: [Setting up the web service](https://ies-svn.jrc.ec.europa.eu/projects/registry-development/wiki/Re3gistry_1_2_documentation#56-Setting-up-the-web-service-Serving-the-registry-contents)

### Folder: data ###
It contains the data file (containing the example data items) to be used with the Re3gistry software.

### Folder: database ###
This folder contains the script to initialize tthe database for the Re3gistry software. They have to be started in the following sequence:
1. create-table.sql
2. database-initialization.sql
3. database-localization.sql
The drop-table.sql is only needed in case of reset of the database. In this case, it has to be executed as first.

More info: [Database creation and initialization](https://ies-svn.jrc.ec.europa.eu/projects/registry-development/wiki/Re3gistry_1_2_documentation#513-Database-creation-and-initialization)

### Folder: deployer ###
The folder contains the examle rss for the deployer module of the Re3gistry software.

### Folder: solr ###
It contains the solr schema file, to set up the solr core for the web service (more info: [SOLR data import](https://ies-svn.jrc.ec.europa.eu/projects/registry-development/wiki/Re3gistry_1_2_documentation#57-SOLR-data-import-Frontend-searching-system)).

### Folder: webapp-configurations ###
It contains the configuration files needed to set up the web application that expose the web service.

### Folder: xsd-schemas ###
The folder contains the xsd schema for the XML format produced by the Re3gistry software.

### Folder: xsl ###
It contins the XSL transformation files to be used by the R3gistry software to produce the different formats (more info: [Data staticization process](https://ies-svn.jrc.ec.europa.eu/projects/registry-development/wiki/Re3gistry_1_2_documentation#381-Data-staticization-process)). 