/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package eu.europa.ec.re3gistrydeployer.servlet;

import eu.europa.ec.re3gistrycommon.managers.DataprocedureMgr;
import eu.europa.ec.re3gistrycommon.managers.ProcedurestatusMgr;
import eu.europa.ec.re3gistrycommon.model.Dataprocedure;
import eu.europa.ec.re3gistrycommon.model.Procedurestatus;
import eu.europa.ec.re3gistrycommon.utils.PersistenceFactory;
import eu.europa.ec.re3gistrycommon.utils.StringUtils;
import eu.europa.ec.re3gistrydeployer.constants.Constants;
import eu.europa.ec.re3gistrydeployer.managers.PropertyMgr;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Properties;
import javax.persistence.EntityManager;
import javax.servlet.ServletException;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.apache.commons.io.FileUtils;
import org.apache.log4j.Logger;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.ls.DOMImplementationLS;
import org.w3c.dom.ls.LSSerializer;

public class Deploy extends HttpServlet {

    Process pb;
    private static final Logger log = Logger.getLogger(Constants.MODULE_NAME);

    public void startDeploy(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        EntityManager em = null;
        try {

            String rssParam = (String) request.getParameter(Constants.RSS_REQ_ATTR);

            if (rssParam!=null) {
                String rssText = (String) request.getParameter(Constants.RSS_REQ_STR);
                String rssTitle = (String) request.getParameter(Constants.RSS_REQ_TITLE);
                this.updateRSS(rssTitle, rssText);
            }

            this.pb = Runtime.getRuntime().exec(getScriptByOS());

            String line;
            BufferedReader input = new BufferedReader(new InputStreamReader(this.pb.getInputStream()));

            while ((line = input.readLine()) != null) {
                log.info(line);
            }
            input.close();

            //Update deployer table
            em = PersistenceFactory.getEntityManagerFactory().createEntityManager();
            em.getTransaction().begin();

            DataprocedureMgr dataprocedureMgr = new DataprocedureMgr(em);
            ProcedurestatusMgr procedurestatusMgr = new ProcedurestatusMgr(em);
            Procedurestatus procedurestatusCompleted = procedurestatusMgr.getStatusByUuid(eu.europa.ec.re3gistrycommon.constants.Constants.ID_COMPLETED_STATUS);
            List<Dataprocedure> dataprocedures = dataprocedureMgr.findByProcedurestatus(procedurestatusCompleted);
            Iterator<Dataprocedure> itr = dataprocedures.iterator();

            while (itr.hasNext()) {
                Dataprocedure tmp = itr.next();
                if (!tmp.getProcedurestatus().getUuid().equals(eu.europa.ec.re3gistrycommon.constants.Constants.ID_FAILED_STATUS)) {
                }
                dataprocedureMgr.updateDataProcedureStatus(em, tmp, eu.europa.ec.re3gistrycommon.constants.Constants.ID_DEPLOYED_STATUS);
            }

            em.getTransaction().commit();

            request.setAttribute(Constants.KEY_SUCCESS, 1);
        } catch (Exception e) {
            request.setAttribute(Constants.KEY_ERROR, e.getMessage());
        } finally {
            if (em != null && em.isOpen()) {
                em.close();
            }
        }

        request.getRequestDispatcher("./").forward(request, response);
    }

    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        startDeploy(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        startDeploy(request, response);
    }

    private String getScriptByOS() {
        Properties p = PropertyMgr.getProperties();
        String os = System.getProperty("os.name").toLowerCase();
        String scriptFolder = p.getProperty(Constants.KEY_DEPLOY_SCRIPT_FOLDER);

        if (os.indexOf("win") >= 0) {
            return scriptFolder + File.separator + Constants.KEY_WINDOWS_DEPLOY;
        } else {
            return "sh " + scriptFolder + File.separator + Constants.KEY_LINUX_DEPLOY;
        }
    }

    public void updateRSS(String titleIn, String text) {
        Properties p = PropertyMgr.getProperties();
        String rssFile = p.getProperty(Constants.KEY_DEPLOY_RSS_FILE);
        String rssBaseUri = p.getProperty(Constants.KEY_DEPLOY_RSS_BASE_URI);

        try {
            File xmlFile = new File(rssFile);
            if (!xmlFile.exists()) {
                log.error("The source RSS file is not available; please check the configurations for the source RSS file path: " + rssFile);
            }

            DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
            DocumentBuilder docBuilder = docFactory.newDocumentBuilder();
            Document doc = docBuilder.parse(xmlFile);

            Element guid = doc.createElement("guid");
            guid.appendChild(doc.createTextNode(rssBaseUri + "#" + System.currentTimeMillis()));

            Element title = doc.createElement("title");
            title.appendChild(doc.createTextNode(titleIn));

            Element link = doc.createElement("link");
            link.setAttribute("rel", "self");
            link.appendChild(doc.createTextNode(rssBaseUri));

            Element description = doc.createElement("description");
            description.appendChild(doc.createCDATASection(text));

            Element pubdate = doc.createElement("pubDate");
            String datefmt = new SimpleDateFormat("E, d MMM yyyy HH:mm:ss z").format(new Date());
            pubdate.appendChild(doc.createTextNode(datefmt));

            Element item = doc.createElement("item");
            item.appendChild(guid);
            item.appendChild(title);
            item.appendChild(link);
            item.appendChild(description);
            item.appendChild(pubdate);

            Element channel = (Element) doc.getElementsByTagName("channel").item(0);
            channel.insertBefore(item, doc.getElementsByTagName("item").item(0));

            DOMImplementationLS domImplementation = (DOMImplementationLS) doc.getImplementation();
            LSSerializer lsSerializer = domImplementation.createLSSerializer();
            String output = lsSerializer.writeToString(doc);
            output = output.replace("UTF-16", "UTF-8");

            PrintWriter out = new PrintWriter(xmlFile);
            out.println(output);
            out.close();

            //Copying the RSS file to custom export directory.
            String destFilepath = p.getProperty(Constants.KEY_DEPLOY_RSS_TARGET_FOLDER);
            File destFile = new File(destFilepath + Constants.KEY_DEPLOY_RSS_FILENAME);

            //RSS var file
            File varFile = new File(destFilepath + "cn.var");
            File parent = varFile.getParentFile();
            parent.mkdirs();            
            if (!varFile.exists()) {
                varFile.createNewFile();
                PrintWriter writer = new PrintWriter(varFile, "UTF-8");
                writer.println("URI: "+Constants.KEY_DEPLOY_RSS_FILENAME);
                writer.println("Content-language: en,en-EN; q=1.0");
                writer.println("Content-type: text/xml; q=1.0");
                writer.close();
            }

            FileUtils.copyFile(xmlFile, destFile);

        } catch (Exception e) {
            log.error(e);
        }
    }
}
