<?php
	class Paginator{		
		
		private $request;
		private $targetPage;
		private $itemPerPage;
		private $totalPages;
		private $maxAdjacentsPage;
		private $localeObject;
	
		public function __construct($request,$targetPage,$itemPerPage,$totalPages,$maxAdjacentsPage,$localeObject){
			$this->request = $request;
			$this->targetPage = $targetPage;
			$this->itemPerPage = $itemPerPage;
			$this->totalPages = $totalPages;
			$this->maxAdjacentsPage = $maxAdjacentsPage;
			$this->localeObject = $localeObject;
		}
		
		// Getter
		public function getRequest(){ return $this->request; }
		public function getTargetPage(){ return $this->targetPage; }
		public function getItemPerPage(){ return $this->itemPerPage; }
		public function getTotalPages(){ return $this->totalPages; }
		public function getMaxAdjacentsPage(){ return $this->maxAdjacentsPage; }
		
		//Setter
		public function setRequest($request){ $this->request = $request; }
		public function setTargetPage($targetPage){ $this->targetPage = $targetPage; }
		public function setItemPerPage($itemPerPage){ $this->itemPerPage = $itemPerPage; }
		public function setTotalPages($totalPages){ $this->totalPages = $totalPages; }
		public function setMaxAdjacentsPage($maxAdjacentsPage){ $this->maxAdjacentsPage = $maxAdjacentsPage; }
		
		
		//Methods
		
		public function getCurrentPage(){
			$request=$this->request;
			$currentPage=isset($request["p"]) ? htmlspecialchars($request["p"], ENT_QUOTES, 'UTF-8') : NULL;
			return ($currentPage-1)*$this->itemPerPage;	
		}
			
		public function getPageBar(){
			$request=$this->request;
			$q=isset($request["q"]) ? htmlspecialchars($request["q"], ENT_QUOTES, 'UTF-8') : NULL;
			$page=isset($request["p"]) ? htmlspecialchars($request["p"], ENT_QUOTES, 'UTF-8') : NULL;
			$targetpage = $this->targetPage;
			$limit = $this->itemPerPage;
			$total_pages = $this->totalPages;
			$adjacents = $this->maxAdjacentsPage;
			
			/*$additionalParam="";	
			if(count($request)>1){
				unset($request["p"]);
				foreach($request as $k=>$v){
					$additionalParam.="&".$k."=".htmlspecialchars($v, ENT_QUOTES, 'UTF-8');
				}
			}*/
			
			$prevLabel = $this->localeObject->previous;
			$nextLabel = $this->localeObject->next;

			if($page) 
				$start = ($page - 1) * $limit; 			
			else
				$start = 0;
			
			if ($page == 0) $page = 1;
			$prev = $page - 1;
			$next = $page + 1;
			$lastpage = ceil($total_pages/$limit);
			$lpm1 = $lastpage - 1;

			$pagination = "";
			if($lastpage > 1)
			{	
				$pagination .= "<ul class=\"pagination\">";

				if ($page > 1)
					$pagination.= "<li><a aria-label=\"$prevLabel\" href=\"$targetpage?q=$q&p=$prev\"><span aria-hidden=\"true\">$prevLabel</span></a></li>";
				else
					$pagination.= "<li class=\"disabled\"><a aria-label=\"$prevLabel\"><span aria-hidden=\"true\">$prevLabel</span></a></li>";	
				
				if ($lastpage < 7 + ($adjacents * 2))
				{	
					for ($counter = 1; $counter <= $lastpage; $counter++)
					{
						if ($counter == $page)
							$pagination.= "<li class=\"active\"><a>$counter<span class=\"sr-only\"> (current)</span></a></li>";
						else
							$pagination.= "<li><a href=\"$targetpage?q=$q&p=$counter\">$counter</a></li>";					
					}
				}
				elseif($lastpage > 5 + ($adjacents * 2))	
				{

					if($page < 1 + ($adjacents * 2))		
					{
						for ($counter = 1; $counter < 4 + ($adjacents * 2); $counter++)
						{
							if ($counter == $page)
								$pagination.= "<li class=\"active\"><a>$counter<span class=\"sr-only\"> (current)</span></a></li>";
							else
								$pagination.= "<li><a href=\"$targetpage?q=$q&p=$counter\">$counter</a></li>";					
						}
						$pagination.= "<li><a>...</a></li>";
						$pagination.= "<li><a href=\"$targetpage?q=$q&p=$lpm1\">$lpm1</a></li>";
						$pagination.= "<li><a href=\"$targetpage?q=$q&p=$lastpage\">$lastpage</a></li>";		
					}

					elseif($lastpage - ($adjacents * 2) > $page && $page > ($adjacents * 2))
					{
						$pagination.= "<li><a href=\"$targetpage?q=$q&p=1\">1</a></li>";
						$pagination.= "<li><a href=\"$targetpage?q=$q&p=2\">2</a></li>";
						$pagination.= "<li><a>...</a></li>";
						for ($counter = $page - $adjacents; $counter <= $page + $adjacents; $counter++)
						{
							if ($counter == $page)
								$pagination.= "<li class=\"active\"><a>$counter<span class=\"sr-only\"> (current)</span></a></li>";
							else
								$pagination.= "<li><a href=\"$targetpage?q=$q&p=$counter\">$counter</a></li>";					
						}
						$pagination.= "<li><a>...</a></li>";
						$pagination.= "<li><a href=\"$targetpage?q=$q&p=$lpm1\">$lpm1</a></li>";
						$pagination.= "<li><a href=\"$targetpage?q=$q&p=$lastpage\">$lastpage</a></li>";		
					}

					else
					{
						$pagination.= "<li><a href=\"$targetpage?q=$q&p=1\">1</a></li>";
						$pagination.= "<li><a href=\"$targetpage?q=$q&p=2\">2</a></li>";
						$pagination.= "<li><a>...</a></li>";
						for ($counter = $lastpage - (2 + ($adjacents * 2)); $counter <= $lastpage; $counter++)
						{
							if ($counter == $page)
								$pagination.= "<li class=\"active\"><a>$counter<span class=\"sr-only\"> (current)</span></a></li>";
							else
								$pagination.= "<li><a href=\"$targetpage?q=$q&p=$counter\">$counter</a></li>";					
						}
					}
				}
				
				if ($page < $counter - 1) 
					$pagination.= "<li><a aria-label=\"$nextLabel\" href=\"$targetpage?q=$q&p=$next\"><span aria-hidden=\"true\">$nextLabel</span></a></li>";
				else
					$pagination.= "<li class=\"disabled\"><a aria-label=\"$nextLabel\"><span aria-hidden=\"true\">$nextLabel</span></a></li>";
				
				
				$pagination.= "</ul>\n";		
			}
			echo $pagination;
		}
	}
?>	