<?
session_start();
header('Content-Type: application/javascript');

/* Configurations include */
include_once(__DIR__.'/../../app_data/conf.php');

/* Localization initialization */
require_once(APPLICATION_ROOT.'core/classes/Locale.class.php');
$l=new Localization($_REQUEST);
$lang = $l->getCurrentLocale();

/* Init logger */
require_once(APPLICATION_ROOT.'core/classes/log4php/Logger.php');
Logger::configure(APPLICATION_ROOT.LOG_CONFIG_PATH);
$log = Logger::getRootLogger();

/* Utilities initialization */
require_once(APPLICATION_ROOT.'core/classes/Utilities.class.php');
$u=new Utilities($log);

/* Output optimization settings */
if(OPTIMIZE_OUTPUT){
	ob_start(array($u, 'sanitizeOutput'));
}

$ui	= @file_get_contents(UI_LOCALE_FOLDER.'ui.'.$lang.'.json');	
$uij = json_decode($ui);

?>
var surl='<?=SEARCH_AUTOCOMPLETE_URL?>';
$(function() {
	$.cookieNotice({lang:'<?=$lang?>'});
	$('.selectpicker').on('change', function(){
		$.getJSON('<?=APPLICATION_ROOT_URL?>core/services/switch.php?lang='+$(this).find('option:selected').val(), function(data){
			if(data.result == 'true'){
				if(location.href.search(/.((?:[a-z][a-z]+)).html/ig)>=0){
					var tmp = location.href.replace(/.((?:[a-z][a-z]+)).html/ig,'');
					location.href = tmp.substring(0,tmp.lastIndexOf('/'));
				}else{
					location.reload();
				}
			}
		});
	});
	$('#q').autocomplete({
		source:function(request,response){					  
			param='label_ac_<?=$lang?>:"'+request.term+'"';					  
			$.ajax({
				url:surl,
				data: { 
					q:param,
					group:'true',
					'group.field':'label_<?=$lang?>',
					fl:'label_<?=$lang?>,score',
					sort:'score desc',
					wt: 'json'
				}, 
				dataType: 'jsonp',
				jsonp: 'json.wrf',
				success: function(data){
					response($.map(data.grouped['label_<?=$lang?>'].groups, function(item){
						return {label: item.doclist.docs[0]['label_<?=$lang?>'].toLowerCase()}; 
					}));
				}
			}); 
		},
		appendTo: $("form:first"),
		minLength:1,
		mustMatch:true,
		select: function(event, ui ) {
			$('#q').val(ui.item.value);
			$('#sfrm').submit();
		}
	}); 
	$("#q").data("ui-autocomplete")._renderMenu = function( ul, items ) {
		var that = this;		
		ul.attr("class", "nav nav-pills nav-stacked");
		$.each( items, function( index, item ) {
			that._renderItemData( ul, item );
		});
	};
	$('#sfrm').on('submit', function(){
		if($('#q').val().length==0){
			return false
		}else{
			_paq.push(['trackEvent', 'Search', $('#q').val(), 'Search keyword']);
		}
	});

});

/* Datatables */
var i=0;
$('#tbl thead tr').clone().appendTo('#tbl thead');
$('#tbl').DataTable({
	"language":{"url":"<?=APPLICATION_ROOT_URL?>res/js/jquery.dataTables.localization/<?=$lang?>.json"},
	"dom": '<"top">rt<"bottom"lip><"clear">',
	"pagingType":"full_numbers",
	"displayLength":50,
	"stateSave": true,
	"initComplete": function () {
		$('#tbl thead tr:first th').css('text-align','left');
		$('#tbl thead tr:first th').each( function () {
			var title = $('#tbl thead th').eq( $(this).index() ).text();
			var filter = '<?=$uij->{'filter-single'}?>';
			$(this).html( '<input class="fin'+(i++)+' form-control input-sm" type="search" placeholder="'+filter+' '+title+'" aria-controls="tbl" />' );
			$(this).css('padding','1px 0');
		});			
		var api = this.api();
		var state = api.state.loaded();
		if(state){
			api.columns().eq(0).each(function(idx) {
				var colSearch = state.columns[idx].search;	
				$('input.fin'+idx).val(colSearch.search);
				$('input.fin'+idx).on('keyup change',function(){
					api.column(idx).search(this.value).draw();
				} );
			} );
		}else{
			api.columns().eq(0).each(function(idx) {
				$('input.fin'+idx).on('keyup change',function(){
					api.column(idx).search(this.value).draw();
				} );
			} );
		}
		$('#tbl_filter').html("");

		var cols = $("#tbl tr th");
		var colss = cols.length/2;
		var wp = 90/(colss-1);
		
		for(i=0; i<cols.length;i++){
				if(cols.length==2){
					cols[i].style.width = '100%';
				}else if(cols.length==4){
					if($('.tbl-static-2cols').length){
						cols[0].style.width = '20%';
						cols[1].style.width = '80%';
					}else{
						cols[i].style.width = '50%';
					}
				}else if(i==(colss-1) || i==(cols.length-1)){
					cols[i].style.width = '10%';
				}else{
					cols[i].style.width = wp+'%';
				}
		}
		$("#tbl").DataTable().draw();
		
		/* Hide empty columns */
		$('#tbl').DataTable().columns().every(function(){
			var vcnt = 0;
			this.data().each( function ( value, index ) {
				if(value!=''){
					vcnt++;
				}
			});
			if(vcnt==0){
				this.visible(false);
			}
		});
	}
});