/* Configuratons: customizable messages and lables */
var loc = {
	defaultLocale:'en',
	it:{
		title: 'Informazioni sui cookie',
		text: 'Questo sito utilizza i cookie per migliorare l&apos;esplorazione. Scopri come usiamo i cookie e <a target="_blank" href="http://ec.europa.eu/cookies/index_it.htm">come &egrave; possibile modificare le tue impostazioni</a>.',
		buttonLabel: 'Accetto'
	},
	en:{
		title: 'About cookies',
		text: 'This site uses cookies to offer you a better browsing experience. Find out more on <a target="_blank" href="http://ec.europa.eu/cookies/index_en.htm">how we use cookies and how you can change your settings</a>.',
		buttonLabel: 'Accept'
	},
	ro:{
		title: 'Despre cookie-uri',
		text: 'Acest site foloseste cookie-uri pentru a vă oferi o experiență mai bună de navigare. Aflați mai multe despre <a target="_blank" href="http://ec.europa.eu/cookies/index_ro.htm">cum le folosim cookie-urile și cum puteți modifica setările</a>.',
		buttonLabel: 'Acceptă'
	}
}

/*! CookieNotice 0.1 */
$.extend({
	cookieNoticeSet:function(cname, cvalue, exdays, path){
		var d = new Date();
		d.setTime(d.getTime() + (exdays*24*60*60*1000));
		var expires = "expires="+d.toUTCString();
		document.cookie = cname + "=" + cvalue + "; " + expires + "; path="+path;
	},
	cookieNoticeGet:function(cname){
		var name = cname + "=";
		var ca = document.cookie.split(';');
		for(var i=0; i<ca.length; i++) {
			var c = ca[i];
			while (c.charAt(0)==' ') c = c.substring(1);
			if (c.indexOf(name) == 0) return c.substring(name.length,c.length);
		}
		return "";
	},
	cookieNoticeUnbind:function(){
		$.cookieNoticeSet('cookie-notice-flag', 'accept', 30, "/");
		$('.ckn').slideUp();
	},
	cookieNotice: function(opts){
		
		if(!opts || !opts.lang){
			lng = (!$('html').attr('lang'))?loc.defaultLocale:$('html').attr('lang');
		}else{
			lng = opts.lang;
		}
		
		if(opts && opts.loc){
			loc = opts.loc;
		}
		
		if(!loc[lng]){
			lng = loc.defaultLocale;
		}
		
		if(!$.cookieNoticeGet('cookie-notice-flag')){
			if($('#cookieNotice')){
				$('#cookieNotice').remove();
			}
			$('body').prepend('<div id="cookieNotice" class="ckn" style="background-color:#eee;border-bottom:4px solid #696969; margin-bottom:10px; display:none"><div class="container" style="margin-left: auto;margin-right: auto;padding-left: 15px;padding-right: 15px; display:table"><div class="row"><div class="col-sm-10" style="position: relative;"><h4 style="color:#696969; font-size:1em; margin-top:10px; margin-bottom:10px; line-height:1.1"><span class="glyphicon glyphicon-info-sign"></span>&nbsp;'+loc[lng].title+'</h4><p style="font-size:.8em;line-height:1.1">'+loc[lng].text+'</p></div><div class="col-sm-2 pull-right" style="margin-top:10px"><p class="pull-right" style="margin: 0 0 10px;"><button style="border:1px solid transparent; cursor:pointer; background-color:#696969; color:#fff; border-radius:4px; padding:6px 12px;background-image:none" id="ckn" class="btn btn-default"><span class="glyphicon glyphicon-ok"></span>&nbsp;'+loc[lng].buttonLabel+'</button></div></div></div></div>');
			$('.ckn').slideDown();
			if($.fn.on){
				$('#ckn').on('click',function(){
					$.cookieNoticeUnbind();
				});
			}else{
				$('#ckn').bind('click',function(){
					$.cookieNoticeUnbind();
				});
			}			
			if(opts && opts.scroll){
				if($.fn.on){
					$(document).on('scroll',function(event){
						if(!$.cookieNoticeGet('cookie-notice-flag')){
							$.cookieNoticeUnbind();
						}
					});
				}else{
					$(document).bind('scroll',function(event){
						if(!$.cookieNoticeGet('cookie-notice-flag')){
							$.cookieNoticeUnbind();
						}
					});
				}
			}
		}
	}
});
$(function(){$.cookieNotice();})